=== debian/tests/control ===
Depends: @, postgresql-contrib-14
Tests: installcheck
Restrictions: allow-stderr
