=== debian/changelog ===
pg-auto-failover (1.6.4-1.pgdg110+1) bullseye-pgdg; urgency=medium

  * Rebuild for bullseye-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 06 Apr 2022 15:21:56 +0200

pg-auto-failover (1.6.4-1) unstable; urgency=low

  * Official 1.6.4 release of pg_auto_failover

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 06 Apr 2022 15:21:56 +0200
