=== debian/control ===
--- 
+++ 
@@ -15,6 +15,34 @@
  This CLI is used to manage pg_auto_failover installations to provide High
  Availability to Postgres.
 
+Package: postgresql-10-auto-failover
+Architecture: any
+Depends: ${shlibs:Depends},${misc:Depends}, postgresql-10, pg-auto-failover-cli (= ${binary:Version})
+Description: Postgres high availability support
+ This extension implements a set of functions to provide High Availability to
+ Postgres.
+
+Package: postgresql-11-auto-failover
+Architecture: any
+Depends: ${shlibs:Depends},${misc:Depends}, postgresql-11, pg-auto-failover-cli (= ${binary:Version})
+Description: Postgres high availability support
+ This extension implements a set of functions to provide High Availability to
+ Postgres.
+
+Package: postgresql-12-auto-failover
+Architecture: any
+Depends: ${shlibs:Depends},${misc:Depends}, postgresql-12, pg-auto-failover-cli (= ${binary:Version})
+Description: Postgres high availability support
+ This extension implements a set of functions to provide High Availability to
+ Postgres.
+
+Package: postgresql-13-auto-failover
+Architecture: any
+Depends: ${shlibs:Depends},${misc:Depends}, postgresql-13, pg-auto-failover-cli (= ${binary:Version})
+Description: Postgres high availability support
+ This extension implements a set of functions to provide High Availability to
+ Postgres.
+
 Package: postgresql-14-auto-failover
 Architecture: any
 Depends: ${shlibs:Depends},${misc:Depends}, postgresql-14, pg-auto-failover-cli (= ${binary:Version})
