## pg-auto-failover 2.0

=== Makefile ===
--- 
+++ 
@@ -6,9 +6,10 @@
 CONTAINER_NAME = pg_auto_failover
 BUILD_CONTAINER_NAME = pg_auto_failover_build
 TEST_CONTAINER_NAME = pg_auto_failover_test
-DOCKER_RUN_OPTS = --privileged  -ti --rm
-
-PGVERSION ?= 10
+DOCKER_RUN_OPTS = --privileged --rm
+
+PGVERSION ?= 14
+
 NOSETESTS = $(shell which nosetests3 || which nosetests)
 
 # Tests for the monitor
@@ -44,10 +45,20 @@
 TESTS_MULTI += test_multi_maintenance
 TESTS_MULTI += test_multi_standbys
 
+# Tests for Citus
+TESTS_CITUS  = test_basic_citus_operation
+TESTS_CITUS += test_citus_cluster_name
+TESTS_CITUS += test_citus_force_failover
+TESTS_CITUS += test_citus_multi_standbys
+TESTS_CITUS += test_nonha_citus_operation
+TESTS_CITUS += test_citus_skip_pg_hba
+
 # TEST indicates the testfile to run
 TEST ?=
 ifeq ($(TEST),)
 	TEST_ARGUMENT = --where=tests
+else ifeq ($(TEST),citus)
+	TEST_ARGUMENT = --where=tests --tests=$(TESTS_CITUS)
 else ifeq ($(TEST),multi)
 	TEST_ARGUMENT = --where=tests --tests=$(TESTS_MULTI)
 else ifeq ($(TEST),single)
@@ -79,13 +90,25 @@
 NODES_ASYNC ?= 0				# count of replication-quorum false nodes
 NODES_PRIOS ?= 50				# either "50", or "50,50", or "50,50,0" etc
 NODES_SYNC_SB ?= -1
-FIRST_PGPORT ?= 5500
+
+CITUS = 0
+WORKERS = 2
+NODES_SECONDARY = 0
 CLUSTER_OPTS = ""			# could be "--skip-pg-hba"
 
 TMUX_EXTRA_COMMANDS ?= ""
 TMUX_LAYOUT ?= even-vertical	# could be "tiled"
 TMUX_TOP_DIR = ./tmux
 TMUX_SCRIPT = ./tmux/script-$(FIRST_PGPORT).tmux
+
+ifeq ($(CITUS),1)
+	FIRST_PGPORT ?= 5600
+	CLUSTER_OPTS += --citus
+	TMUX_TOP_DIR = ./tmux/citus
+else
+	FIRST_PGPORT ?= 5500
+	TMUX_TOP_DIR = ./tmux/pgsql
+endif
 
 # make azcluster arguments
 AZURE_PREFIX ?= ha-demo-$(shell whoami)
@@ -132,10 +155,31 @@
 install-bin: bin
 	$(MAKE) -C src/bin/ install
 
-
+#
+# make ci-test; is run on the GitHub Action workflow
+#
+# In that environment we have a local git checkout of the code, and docker
+# is available too. We run our tests in docker, except for the code linting
+# parts which requires full access to the git repository, so linter tooling
+# is installed directly on the CI vm.
+#
+ci-test:
+ifeq ($(TEST),tablespaces)
+	$(MAKE) -C tests/tablespaces run-test
+else ifeq ($(TEST),linting)
+	$(MAKE) spellcheck
+else
+	$(MAKE) run-test
+endif
+
+#
+# make test; is run from inside the testing Docker image.
+#
 test:
 ifeq ($(TEST),tablespaces)
 	$(MAKE) -C tests/tablespaces run-test
+else ifeq ($(TEST),linting)
+	$(MAKE) spellcheck
 else
 	sudo -E env "PATH=${PATH}" USER=$(shell whoami) \
 		$(NOSETESTS)			\
@@ -146,34 +190,69 @@
 		${TEST_ARGUMENT}
 endif
 
+#
+# make indent; edits the code when necessary
+#
 indent:
 	citus_indent
 	black .
 
-docs: $(FSM)
+#
+# make lint; is an alias for make spellcheck
+# make linting; is an alias for make spellcheck
+#
+lint: spellcheck ;
+linting: spellcheck ;
+
+#
+# make spellcheck; runs our linting tools without editing the code, only
+# reports compliance with the rules.
+#
+spellcheck:
+	citus_indent --check
+	black --check .
+	ci/banned.h.sh
+
+docs: $(FSM) tikz
 	$(MAKE) -C docs html
+
+tikz:
+	$(MAKE) -C docs/tikz all
 
 interactive-test:
 	docker run --name $(CONTAINER_NAME) --rm -ti $(CONTAINER_NAME)
 
 build-image:
-	docker build $(DOCKER_BUILD_OPTS) --target build -t $(BUILD_CONTAINER_NAME) .
-
-build-test-pg10: build-image
-	docker build --build-arg PGVERSION=10 --target test -t $(TEST_CONTAINER_NAME):pg10 .
+	docker build --target build -t $(BUILD_CONTAINER_NAME) .
+
+# Citus 9.0 seems to be the most recent version of Citus with Postgres 10
+# support, but fails to compile nowadays...
+# build-test-pg10:
+# 	docker build --build-arg PGVERSION=10 --build-arg CITUSTAG=v9.0.2 --target test -t $(TEST_CONTAINER_NAME):pg10 .
 
 build-test-pg11:
-	docker build --build-arg PGVERSION=11 --target test -t $(TEST_CONTAINER_NAME):pg11 .
+	docker build --build-arg PGVERSION=11 --build-arg CITUSTAG=v9.5.10 --target test -t $(TEST_CONTAINER_NAME):pg11 .
 
 build-test-pg12:
-	docker build --build-arg PGVERSION=12 --target test -t $(TEST_CONTAINER_NAME):pg12 .
+	docker build --build-arg PGVERSION=12 --build-arg CITUSTAG=v10.2.3 --target test -t $(TEST_CONTAINER_NAME):pg12 .
 
 build-test-pg13:
-	docker build --build-arg PGVERSION=13 --target test -t $(TEST_CONTAINER_NAME):pg13 .
+	docker build --build-arg PGVERSION=13 --build-arg CITUSTAG=v10.2.3 --target test -t $(TEST_CONTAINER_NAME):pg13 .
 
 build-test-pg14:
-	docker build --build-arg PGVERSION=14 --target test -t $(TEST_CONTAINER_NAME):pg14 .
-
+	docker build --build-arg PGVERSION=14 --build-arg CITUSTAG=v11.1.2 --target test -t $(TEST_CONTAINER_NAME):pg14 .
+
+build-test-pg15:
+	docker build --build-arg PGVERSION=15 --build-arg CITUSTAG=v11.1.2 --target test -t $(TEST_CONTAINER_NAME):pg15 .
+
+
+build-test-image: build-test-pg$(PGVERSION) ;
+
+
+#
+# make run-test; is the main testing entry point used to run tests inside
+# our testing Docker container. The docker container depends on PGVERSION.
+#
 run-test: build-test-pg$(PGVERSION)
 	docker run					                \
 		--name $(TEST_CONTAINER_NAME)		    \
@@ -182,30 +261,36 @@
 		make -C /usr/src/pg_auto_failover test	\
 		PGVERSION=$(PGVERSION) TEST='${TEST}'
 
-build-pg10: build-test-pg10
-	docker build --build-arg PGVERSION=10 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg10 .
+# build-pg10: build-test-pg10
+# 	docker build --build-arg PGVERSION=10 -t $(CONTAINER_NAME):pg10 .
 
 build-pg11: build-test-pg11
-	docker build --build-arg PGVERSION=11 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg11 .
+	docker build --build-arg PGVERSION=11 -t $(CONTAINER_NAME):pg11 .
 
 build-pg12: build-test-pg12
-	docker build --build-arg PGVERSION=12 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg12 .
+	docker build --build-arg PGVERSION=12 -t $(CONTAINER_NAME):pg12 .
 
 build-pg13: build-test-pg13
-	docker build --build-arg PGVERSION=13 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg13 .
+	docker build --build-arg PGVERSION=13 -t $(CONTAINER_NAME):pg13 .
 
 build-pg14: build-test-pg14
-	docker build --build-arg PGVERSION=14 $(DOCKER_BUILD_OPTS) -t $(CONTAINER_NAME):pg14 .
-
-build: build-pg10 build-pg11 build-pg12 build-pg13 build-pg14 ;
+	docker build --build-arg PGVERSION=14 -t $(CONTAINER_NAME):pg14 .
+
+build-pg15: build-test-pg15
+	docker build --build-arg PGVERSION=15 -t $(CONTAINER_NAME):pg15 .
+
+build: build-pg11 build-pg12 build-pg13 build-pg14 build-pg15 ;
 
 build-check:
-	for v in 10 11 12 13 14; do \
+	for v in 11 12 13 14 15; do \
 		docker run --rm -t pg_auto_failover_test:pg$$v pg_autoctl version --json | jq ".pg_version" | xargs echo $$v: ; \
 	done
 
 build-i386:
 	docker build -t i386:latest -f Dockerfile.i386 .
+
+build-demo:
+	docker build -t citusdata/pg_auto_failover:demo .
 
 # expected to be run from within the i386 docker container
 installcheck-i386:
@@ -219,7 +304,7 @@
 man:
 	$(MAKE) -C docs man
 
-pdf: $(PDF)
+pdf: $(PDF) ;
 
 $(PDF):
 	$(MAKE) -s -C docs/tikz pdf
@@ -242,6 +327,8 @@
          --async-nodes $(NODES_ASYNC)     \
          --node-priorities $(NODES_PRIOS) \
          --sync-standbys $(NODES_SYNC_SB) \
+         --citus-workers $(WORKERS) \
+         --citus-secondaries $(NODES_SECONDARY) \
          $(CLUSTER_OPTS)                  \
          --binpath $(BINPATH)             \
 		 --layout $(TMUX_LAYOUT) > $@
@@ -252,7 +339,10 @@
 	$(PG_AUTOCTL) do tmux clean           \
          --root $(TMUX_TOP_DIR)           \
          --first-pgport $(FIRST_PGPORT)   \
-         --nodes $(NODES)
+         --nodes $(NODES)                 \
+         --citus-workers $(WORKERS)       \
+         --citus-secondaries $(NODES_SECONDARY) \
+         $(CLUSTER_OPTS)
 
 tmux-session: bin
 	$(PG_AUTOCTL) do tmux session         \
@@ -262,6 +352,8 @@
          --async-nodes $(NODES_ASYNC)     \
          --node-priorities $(NODES_PRIOS) \
          --sync-standbys $(NODES_SYNC_SB) \
+         --citus-workers $(WORKERS)       \
+         --citus-secondaries $(NODES_SECONDARY) \
          $(CLUSTER_OPTS)                  \
          --binpath $(BINPATH)             \
          --layout $(TMUX_LAYOUT)
@@ -274,6 +366,8 @@
          --async-nodes $(NODES_ASYNC)     \
          --node-priorities $(NODES_PRIOS) \
          --sync-standbys $(NODES_SYNC_SB) \
+         --citus-workers $(WORKERS)       \
+         --citus-secondaries $(NODES_SECONDARY) \
          $(CLUSTER_OPTS)                  \
          --binpath $(BINPATH)             \
          --layout $(TMUX_LAYOUT)
@@ -290,8 +384,8 @@
 valgrind-session: build-test
 	docker run                             \
 	    --name $(TEST_CONTAINER_NAME) 	   \
-		$(DOCKER_RUN_OPTS)			       \
-		$(TEST_CONTAINER_NAME)			   \
+		$(DOCKER_RUN_OPTS) -it		       \
+		$(TEST_CONTAINER_NAME):pg14		   \
 	    make -C /usr/src/pg_auto_failover  \
 	     VALGRIND=1 					   \
 	     TMUX_TOP_DIR=/tmp/tmux 	       \
@@ -318,13 +412,4 @@
 azdrop: all
 	$(PG_AUTOCTL) do azure drop
 
-.PHONY: all clean check install docs
-.PHONY: monitor clean-monitor check-monitor install-monitor
-.PHONY: bin clean-bin install-bin
-.PHONY: build-test run-test
-.PHONY: tmux-clean cluster compose
-.PHONY: azcluster azdrop az
-.PHONY: build-image
-.PHONY: build-test-pg10 build-test-pg11 build-test-pg142
-.PHONY: build-test-pg13 build-test-pg14
-.PHONY: build build-pg10 build-pg11 build-pg12 build-pg13 build-pg14
+.PHONY: all clean check install docs tikz
