=== debian/tests/control ===
Depends: @, postgresql-contrib-15
Tests: installcheck
Restrictions: allow-stderr
